#include <iostream>
#include <sys/stat.h>
#include <vector>

#define TIXML_USE_STL 
#include <tinyxml.h>

using namespace std;

char whdrunnerconfigdef[]=".whdrunnerrc";
char *whdrunnerconfig=whdrunnerconfigdef;

char uaebinarydef[]="fs-uae";
char *uaebinary=uaebinarydef;

char hard_drive_0[500]="~/.whdrunner/dh0";
char hard_drive_1[500]="~/.whdrunner/dh1";

char fsuaeconf[500]="~/.config/fs-uae/fs-uae.conf";

bool thisrom=0;
char whdloadparam[100] = {0};
char cdpathparam[100] = {0};
char uaeconfigparam[100] = {0};
char *cfgvalue;
char configfile[500];
char userstartup[300];
char homedir[255];
char rompath[500];
char usedrom[500];
int gamecount=0;
bool gamefoundindb=0;

void splitfullpath(char *path)
{
	char *str = path;

	if ((str = strrchr(path, '/')))
	{str++;}
	strcpy (usedrom,str);
}

char* setenvhome(char* checky)
{
	char *checktilde = strchr(checky, '~');
	if (checktilde)
	{
		char temppath[500];
		char gethome[150];
		sprintf(temppath, "%s",checky+1);
		strcpy(gethome, getenv("HOME"));
		strcat (gethome, temppath);
		strcpy(checky, gethome);
	}
	return checky;
}

void saveuserstartup()
{
	setenvhome(hard_drive_0);

	strcpy(userstartup, hard_drive_0);
	strcat(userstartup, "/S/user-startup");

	FILE *newuserstartup = fopen(userstartup,"wt");
	fprintf(newuserstartup,"cd %s\n",cdpathparam);
	fprintf(newuserstartup,"whdload %s\n",whdloadparam);
	fclose(newuserstartup);
}

class whddata {
	public:
		std::string fntemp;
		std::string whdtemp;
		std::string cdtemp;
		std::string uaetemp;
		
		whddata() : fntemp("nofn"), whdtemp("nowhd"), cdtemp("nocd"),uaetemp("nouae") {}

		void parsetxt(const char* usedrom)	
		{
			if (strcmp(fntemp.c_str(), usedrom) == 0)
			{thisrom=1;	gamefoundindb=1;}
			if (strcmp(fntemp.c_str(), usedrom) != 0)
			{thisrom=0;}	
			
			if(thisrom)
			{
				strcpy(whdloadparam, whdtemp.c_str());
//				printf("whdloadparam is %s\n",whdloadparam);

				strcpy(cdpathparam, cdtemp.c_str());
//				printf("cdpathparam is %s\n",cdpathparam);	
				
//				strcpy(uaeconfigparam, uaetemp.c_str());
//				printf("uaeconfigparam is %s\n",uaeconfigparam);					
			}
		}
 	private:
};

void parsexml(const char* pcFilename, const char* usedrom)
{

        // first load the xml file
	TiXmlDocument doc(pcFilename);
	if(!doc.LoadFile())
	{
		cout << "Error: could not load file: " << pcFilename << endl;
		return;
	}
	TiXmlElement* pElem;
	TiXmlElement* pChild;
	TiXmlHandle hDoc(&doc);
	TiXmlHandle hRoot(0);
	vector<whddata> whdlist;
		
	pElem = hDoc.FirstChildElement().Element();
	
	hRoot = TiXmlHandle(pElem);

	whdlist.clear();

		for(pElem=hRoot.FirstChild("Game").Element(); pElem; pElem = pElem->NextSiblingElement())
 	    {
 	    	whddata cur;

 	    	pChild = hRoot.Child("Game",gamecount).Element();
 	    	if(pChild) { 

  			if(pChild->Attribute("FileName"))	{cur.fntemp = pChild->Attribute("FileName");}
  			if(pChild->Attribute("WHDLoad"))	{cur.whdtemp = pChild->Attribute("WHDLoad");}
  			if(pChild->Attribute("Cd"))			{cur.cdtemp = pChild->Attribute("Cd");}
 // 			if(pChild->Attribute("UAEConfig"))	{cur.uaetemp = pChild->Attribute("UAEConfig");}		
  			
  			whdlist.push_back(cur);
 	    	gamecount++;
			}
 	    }
 	    
		gamecount=0;
 	    
 	    for(vector<whddata>::iterator iter=whdlist.begin();
 	    	iter != whdlist.end(); iter++)
       	{
   			iter->parsetxt(usedrom);
       		gamecount++;
   		}

	if (gamefoundindb==0)	
	{
		printf("ERROR!   your game was not found in the db - exiting!\n");
		exit(0);
	}
}

// lame system unzip - TODO maybe replace later 

void extractromzip()
{
	char extractgame[250];
	strcpy(extractgame, "unzip -u ");
	strcat(extractgame, rompath);
	strcat(extractgame, " -d ");
	strcat(extractgame, hard_drive_1);
	int start = 0;
	start=system(extractgame);
	if (start == -1) {printf("WARNING - can't start %s\n",extractgame); }	
}

void cfgpath(char *configname)
{
	strcpy(homedir, getenv("HOME"));
	strcpy(configfile,homedir);
	strcat(configfile,"/.whdrunner/");
	mkdir(configfile, 0755);
	strcat(configfile, configname);
}

char *readconfig(char configfile[], const char entry[])
{
	int cfglinelength=300;
	char buffer[cfglinelength];
	char *foundentry;
	int entrylength = 0;
	FILE *cfgFile = fopen(configfile,"r");

	if (!cfgFile)
	{
	return 0;
	} 

	while (fgets(buffer, cfglinelength, cfgFile))
	{
	if (buffer[0]==';') {continue;}

	foundentry = buffer;
	while (*foundentry && *foundentry!='=') {foundentry++;}
	if (*foundentry!='=') {continue;}

	*foundentry-- = 0; // delete " " before the "="
	*foundentry++ = 0; // delete " " before the "="
	*foundentry++ = 0; // delete "="
	*foundentry++ = 0; // delete " " after the "="

	// Skip to end of string and delete lf (=line feed char)
	while (*foundentry) {foundentry++; entrylength++;} *--foundentry = 0;

	// move to the beginning of the value of the entry
	for(int i = entrylength-1; i > 0; i--){foundentry--;}
	entrylength = 0;

	if(strcmp(buffer, entry) == 0) // found the entry we were looking for
		{
		char *returnValue = new char[cfglinelength];
		strcpy( returnValue, foundentry );
		fclose (cfgFile);
		return returnValue;
		}
	} // = end of skipping through the lines
	fclose(cfgFile);
	return 0;
}

void saveconfig()
{
	FILE *newconfigfile = fopen(configfile,"w");
	fprintf(newconfigfile,";\n");
	fprintf(newconfigfile,"uaebinary = %s\n",uaebinary);
	fprintf(newconfigfile,"fsuaeconf = %s\n",fsuaeconf);

	fclose(newconfigfile);
}

void checkcfg()
{
	FILE *cfgcheck = fopen(configfile,"r");
	if(!cfgcheck)
	{
	printf("whdrunner configuration ~/.whdrunner/.whdrunnerrc wasn't found. Creating a default one and exiting!\n");
	saveconfig();
	exit(0);
	}
	else {fclose(cfgcheck);}
}

void readvars()
{
	cfgvalue = readconfig(configfile, "uaebinary");
	if (cfgvalue)	uaebinary = (cfgvalue);

	cfgvalue = readconfig(configfile, "fsuaeconf");
	if (cfgvalue)	strcpy(fsuaeconf,cfgvalue);
}

void checkfsuaecfg()
{
	FILE *cfgcheck = fopen(setenvhome(fsuaeconf),"r");
	if(!cfgcheck)
	{
	printf("ERROR - fsuaeconf %s wasn't found. Create and configure it before using whdrunner!\n",fsuaeconf);
	exit(0);
	}
	else {fclose(cfgcheck);}
}

void nohd(char* hd) {printf("ERROR - couldn't read %s from fsuaeconf %s - Exiting!\n",hd,fsuaeconf);exit(0);}

void readfsuaevars()
{
	cfgvalue = readconfig(fsuaeconf, "hard_drive_0");
	if (cfgvalue)	strcpy(hard_drive_0,cfgvalue);
	else 		{nohd((char*)"hard_drive_0");}
	
	cfgvalue = readconfig(fsuaeconf, "hard_drive_1");
	if (cfgvalue)	{
						strcpy(hard_drive_1,cfgvalue);
						mkdir(hard_drive_1, 0755);
					}
	else 		{nohd((char*)"hard_drive_1");}
}

int main(int argc, char* argv[])
{
	cfgpath(whdrunnerconfig);
	checkcfg();
	readvars();

	checkfsuaecfg();
	readfsuaevars();

	for (int i=1; i<argc; i++)
	{
		strcpy (rompath,argv[i]);
		splitfullpath(argv[i]);
	}

	if(!argv[1])
	{
		printf("ERROR!   need an absolute path to a zipped whdload game as commandline argument - exiting!\n");
		return -1;
	}

	FILE* testparm=fopen(rompath, "rb");
	if(!testparm)
	{
		printf("ERROR!   file provided as commandline argument can't be opened - exiting!\n");
		return -1;
	}
	char whdloadxmlpath[500];
	strcpy(whdloadxmlpath, PKGDATADIR);
	strcat(whdloadxmlpath,"/WHDLoad.xml");
	
	parsexml(whdloadxmlpath,usedrom);

	saveuserstartup();
	extractromzip();

	int start = 0;
	start=system(uaebinary);
	if (start == -1) {printf("WARNING - can't start %s\n",uaebinary); }

	return -1;
}

